//+------------------------------------------------------------------+
//|                                                  Force Index.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DodgerBlue
#property indicator_width1  3
#property indicator_level1  0
#property indicator_levelcolor Gold






extern int    swingCount          = 5;
extern int    ForceMAMethod       = 0;
extern int    ForceAppliedPrice   = 0;
extern double speed               = 1.0;
extern bool   alertsOn            = false;
extern bool   alertsOnCurrent     = false;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = true;
extern bool   alertsEmail         = false;

double ForceBuffer[];
double swingBuffer[];
double cross[];




int init()
  {
   IndicatorBuffers(3);
   SetIndexBuffer(0,ForceBuffer);SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,swingBuffer);
   SetIndexBuffer(2,cross);
   speed = MathMax(speed,0.000001);
   



   return(0);
  }


int deinit() { return(0); }




int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      int swing = 0;
         if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swing = -1;
         if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swing =  1;
      swingBuffer[i] = swing;
   
      //
      //
      //
      //
      //
      int k = i;
      int n = 0;
      for (; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
      double ForcePeriod = MathMax(MathRound((k-i)/swingCount/speed),1);
      ForceBuffer[i]=Volume[i]*(iMA(NULL,0,ForcePeriod,0,ForceMAMethod,ForceAppliedPrice,i)-iMA(NULL,0,ForcePeriod,0,ForceMAMethod,ForceAppliedPrice,i+1));
         cross[i] = cross[i+1];
         if (ForceBuffer[i]>0) cross[i] =  1;
         if (ForceBuffer[i]<0) cross[i] = -1;
   }
   manageAlerts();
   return(0);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (cross[whichBar] != cross[whichBar+1])
      {
         if (cross[whichBar] ==  1) doAlert(time1,mess1,whichBar,"Crossed zero line up");
         if (cross[whichBar] == -1) doAlert(time1,mess1,whichBar,"Crossed zero line down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" alb force index "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," alb force index "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}